_Init_MPU:
;MPU_IMU_I2C.c,30 :: 		void Init_MPU(){
ADDIU	SP, SP, -24
SW	RA, 0(SP)
;MPU_IMU_I2C.c,33 :: 		dat = 0x6c;
SW	R25, 4(SP)
SW	R26, 8(SP)
SW	R27, 12(SP)
SW	R28, 16(SP)
ORI	R2, R0, 108
SB	R2, 20(SP)
;MPU_IMU_I2C.c,34 :: 		MPU_I2C_Write(mpu_I2C_ADDR, mpu_rm_PWR_MGMT_1 , 1, &dat);
ADDIU	R2, SP, 20
MOVZ	R28, R2, R0
ORI	R27, R0, 1
ORI	R26, R0, 107
ORI	R25, R0, 210
JAL	_MPU_I2C_Write+0
NOP	
;MPU_IMU_I2C.c,35 :: 		Delay_ms(100);
LUI	R24, 40
ORI	R24, R24, 45226
L_Init_MPU0:
ADDIU	R24, R24, -1
BNE	R24, R0, L_Init_MPU0
NOP	
;MPU_IMU_I2C.c,36 :: 		dat = 0x00;
SB	R0, 20(SP)
;MPU_IMU_I2C.c,37 :: 		MPU_I2C_Write(mpu_I2C_ADDR, mpu_rm_PWR_MGMT_1 , 1, &dat);      //   MPU_I2C_Write(mpu_I2C_ADDR, mpu_rm_PWR_MGMT_1 , 1, 0x00);
ADDIU	R2, SP, 20
MOVZ	R28, R2, R0
ORI	R27, R0, 1
ORI	R26, R0, 107
ORI	R25, R0, 210
JAL	_MPU_I2C_Write+0
NOP	
;MPU_IMU_I2C.c,38 :: 		Delay_ms(100);
LUI	R24, 40
ORI	R24, R24, 45226
L_Init_MPU2:
ADDIU	R24, R24, -1
BNE	R24, R0, L_Init_MPU2
NOP	
;MPU_IMU_I2C.c,39 :: 		dat = 0x69;
ORI	R2, R0, 105
SB	R2, 20(SP)
;MPU_IMU_I2C.c,40 :: 		MPU_I2C_Write(mpu_I2C_ADDR, mpu_rm_FIFO_EN , 1, &dat);         //   MPU_I2C_Write(mpu_I2C_ADDR, mpu_rm_FIFO_EN , 1, 0x78);
ADDIU	R2, SP, 20
MOVZ	R28, R2, R0
ORI	R27, R0, 1
ORI	R26, R0, 35
ORI	R25, R0, 210
JAL	_MPU_I2C_Write+0
NOP	
;MPU_IMU_I2C.c,41 :: 		Delay_ms(100);
LUI	R24, 40
ORI	R24, R24, 45226
L_Init_MPU4:
ADDIU	R24, R24, -1
BNE	R24, R0, L_Init_MPU4
NOP	
;MPU_IMU_I2C.c,42 :: 		dat = 0xA1;
ORI	R2, R0, 161
SB	R2, 20(SP)
;MPU_IMU_I2C.c,43 :: 		MPU_I2C_Write(mpu_I2C_ADDR, mpu_rm_INT_ENABLE , 1, &dat);      //     MPU_I2C_Write(mpu_I2C_ADDR, mpu_rm_INT_ENABLE , 1, 0x10);
ADDIU	R2, SP, 20
MOVZ	R28, R2, R0
ORI	R27, R0, 1
ORI	R26, R0, 56
ORI	R25, R0, 210
JAL	_MPU_I2C_Write+0
NOP	
;MPU_IMU_I2C.c,44 :: 		Delay_ms(100);
LUI	R24, 40
ORI	R24, R24, 45226
L_Init_MPU6:
ADDIU	R24, R24, -1
BNE	R24, R0, L_Init_MPU6
NOP	
;MPU_IMU_I2C.c,45 :: 		MPU_I2C_Read (mpu_I2C_ADDR, mpu_rm_ACCEL_CONFIG, 1, &raw_data);
LUI	R28, #hi_addr(_raw_data+0)
ORI	R28, R28, #lo_addr(_raw_data+0)
ORI	R27, R0, 1
ORI	R26, R0, 28
ORI	R25, R0, 210
JAL	_MPU_I2C_Read+0
NOP	
;MPU_IMU_I2C.c,46 :: 		Delay_ms(100);
LUI	R24, 40
ORI	R24, R24, 45226
L_Init_MPU8:
ADDIU	R24, R24, -1
BNE	R24, R0, L_Init_MPU8
NOP	
;MPU_IMU_I2C.c,47 :: 		raw_data[0] |= 0x18;
LHU	R2, Offset(_raw_data+0)(GP)
ORI	R2, R2, 24
SH	R2, Offset(_raw_data+0)(GP)
;MPU_IMU_I2C.c,48 :: 		MPU_I2C_Write(mpu_I2C_ADDR, mpu_rm_ACCEL_CONFIG, 1, &raw_data[0]);
LUI	R28, #hi_addr(_raw_data+0)
ORI	R28, R28, #lo_addr(_raw_data+0)
ORI	R27, R0, 1
ORI	R26, R0, 28
ORI	R25, R0, 210
JAL	_MPU_I2C_Write+0
NOP	
;MPU_IMU_I2C.c,49 :: 		Delay_ms(100);
LUI	R24, 40
ORI	R24, R24, 45226
L_Init_MPU10:
ADDIU	R24, R24, -1
BNE	R24, R0, L_Init_MPU10
NOP	
;MPU_IMU_I2C.c,50 :: 		MPU_I2C_Read (mpu_I2C_ADDR, mpu_rm_INT_ENABLE, 1, &raw_data);
LUI	R28, #hi_addr(_raw_data+0)
ORI	R28, R28, #lo_addr(_raw_data+0)
ORI	R27, R0, 1
ORI	R26, R0, 56
ORI	R25, R0, 210
JAL	_MPU_I2C_Read+0
NOP	
;MPU_IMU_I2C.c,51 :: 		Delay_ms(100);
LUI	R24, 40
ORI	R24, R24, 45226
L_Init_MPU12:
ADDIU	R24, R24, -1
BNE	R24, R0, L_Init_MPU12
NOP	
;MPU_IMU_I2C.c,52 :: 		raw_data[0] |= 0x11;
LHU	R2, Offset(_raw_data+0)(GP)
ORI	R2, R2, 17
SH	R2, Offset(_raw_data+0)(GP)
;MPU_IMU_I2C.c,53 :: 		MPU_I2C_Write(mpu_I2C_ADDR, mpu_rm_INT_ENABLE, 1, &raw_data[0]);
LUI	R28, #hi_addr(_raw_data+0)
ORI	R28, R28, #lo_addr(_raw_data+0)
ORI	R27, R0, 1
ORI	R26, R0, 56
ORI	R25, R0, 210
JAL	_MPU_I2C_Write+0
NOP	
;MPU_IMU_I2C.c,54 :: 		Delay_ms(100);
LUI	R24, 40
ORI	R24, R24, 45226
L_Init_MPU14:
ADDIU	R24, R24, -1
BNE	R24, R0, L_Init_MPU14
NOP	
;MPU_IMU_I2C.c,55 :: 		}
L_end_Init_MPU:
LW	R28, 16(SP)
LW	R27, 12(SP)
LW	R26, 8(SP)
LW	R25, 4(SP)
LW	RA, 0(SP)
ADDIU	SP, SP, 24
JR	RA
NOP	
; end of _Init_MPU
_Extract_Readings:
;MPU_IMU_I2C.c,60 :: 		void Extract_Readings() {
ADDIU	SP, SP, -4
SW	RA, 0(SP)
;MPU_IMU_I2C.c,62 :: 		accel_x_temp = raw_data[0];
LHU	R2, Offset(_raw_data+0)(GP)
SH	R2, Offset(_accel_x_temp+0)(GP)
;MPU_IMU_I2C.c,63 :: 		accel_x = (float)accel_x_temp / 2048.0;
LH	R4, Offset(_raw_data+0)(GP)
JAL	__SignedIntegralToFLoat+0
NOP	
LUI	R6, 17664
ORI	R6, R6, 0
MOVZ	R4, R2, R0
JAL	__Div_FP+0
NOP	
SW	R2, Offset(_accel_x+0)(GP)
;MPU_IMU_I2C.c,64 :: 		accel_y_temp = raw_data[1];
LHU	R2, Offset(_raw_data+2)(GP)
SH	R2, Offset(_accel_y_temp+0)(GP)
;MPU_IMU_I2C.c,65 :: 		accel_y = (float)accel_y_temp / 2048.0;
LH	R4, Offset(_raw_data+2)(GP)
JAL	__SignedIntegralToFLoat+0
NOP	
LUI	R6, 17664
ORI	R6, R6, 0
MOVZ	R4, R2, R0
JAL	__Div_FP+0
NOP	
SW	R2, Offset(_accel_y+0)(GP)
;MPU_IMU_I2C.c,66 :: 		accel_z_temp = raw_data[2];
LHU	R2, Offset(_raw_data+4)(GP)
SH	R2, Offset(_accel_z_temp+0)(GP)
;MPU_IMU_I2C.c,67 :: 		accel_z = (float)accel_z_temp / 2048.0;
LH	R4, Offset(_raw_data+4)(GP)
JAL	__SignedIntegralToFLoat+0
NOP	
LUI	R6, 17664
ORI	R6, R6, 0
MOVZ	R4, R2, R0
JAL	__Div_FP+0
NOP	
SW	R2, Offset(_accel_z+0)(GP)
;MPU_IMU_I2C.c,70 :: 		temp_raw = raw_data[3];
LHU	R2, Offset(_raw_data+6)(GP)
SH	R2, Offset(_temp_raw+0)(GP)
;MPU_IMU_I2C.c,71 :: 		temp = (float)temp_raw / 340.0;
LH	R4, Offset(_raw_data+6)(GP)
JAL	__SignedIntegralToFLoat+0
NOP	
LUI	R6, 17322
ORI	R6, R6, 0
MOVZ	R4, R2, R0
JAL	__Div_FP+0
NOP	
SW	R2, Offset(_temp+0)(GP)
;MPU_IMU_I2C.c,74 :: 		gyro_x_temp = raw_data[4];
LHU	R2, Offset(_raw_data+8)(GP)
SH	R2, Offset(_gyro_x_temp+0)(GP)
;MPU_IMU_I2C.c,75 :: 		gyro_x = (float)gyro_x_temp / 131.0;
LH	R4, Offset(_raw_data+8)(GP)
JAL	__SignedIntegralToFLoat+0
NOP	
LUI	R6, 17155
ORI	R6, R6, 0
MOVZ	R4, R2, R0
JAL	__Div_FP+0
NOP	
SW	R2, Offset(_gyro_x+0)(GP)
;MPU_IMU_I2C.c,76 :: 		gyro_y_temp = raw_data[5];
LHU	R2, Offset(_raw_data+10)(GP)
SH	R2, Offset(_gyro_y_temp+0)(GP)
;MPU_IMU_I2C.c,77 :: 		gyro_y = (float)gyro_y_temp / 131.0;
LH	R4, Offset(_raw_data+10)(GP)
JAL	__SignedIntegralToFLoat+0
NOP	
LUI	R6, 17155
ORI	R6, R6, 0
MOVZ	R4, R2, R0
JAL	__Div_FP+0
NOP	
SW	R2, Offset(_gyro_y+0)(GP)
;MPU_IMU_I2C.c,78 :: 		gyro_z_temp = raw_data[6];
LHU	R2, Offset(_raw_data+12)(GP)
SH	R2, Offset(_gyro_z_temp+0)(GP)
;MPU_IMU_I2C.c,79 :: 		gyro_z = (float)gyro_z_temp / 131.0;
LH	R4, Offset(_raw_data+12)(GP)
JAL	__SignedIntegralToFLoat+0
NOP	
LUI	R6, 17155
ORI	R6, R6, 0
MOVZ	R4, R2, R0
JAL	__Div_FP+0
NOP	
SW	R2, Offset(_gyro_z+0)(GP)
;MPU_IMU_I2C.c,80 :: 		}
L_end_Extract_Readings:
LW	RA, 0(SP)
ADDIU	SP, SP, 4
JR	RA
NOP	
; end of _Extract_Readings
_Set_Offset:
;MPU_IMU_I2C.c,83 :: 		void Set_Offset() {
ADDIU	SP, SP, -4
SW	RA, 0(SP)
;MPU_IMU_I2C.c,85 :: 		accel_x += Accelx_offset;
LW	R6, Offset(_accel_x+0)(GP)
LUI	R4, 48527
ORI	R4, R4, 23593
JAL	__Add_FP+0
NOP	
SW	R2, Offset(_accel_x+0)(GP)
;MPU_IMU_I2C.c,86 :: 		accel_y += Accely_offset;
LW	R6, Offset(_accel_y+0)(GP)
LUI	R4, 15523
ORI	R4, R4, 55050
JAL	__Add_FP+0
NOP	
SW	R2, Offset(_accel_y+0)(GP)
;MPU_IMU_I2C.c,87 :: 		accel_z += Accelz_offset;
LW	R6, Offset(_accel_z+0)(GP)
LUI	R4, 15948
ORI	R4, R4, 52429
JAL	__Add_FP+0
NOP	
SW	R2, Offset(_accel_z+0)(GP)
;MPU_IMU_I2C.c,90 :: 		temp += Temp_offset;
LW	R6, Offset(_temp+0)(GP)
LUI	R4, 16914
ORI	R4, R4, 7864
JAL	__Add_FP+0
NOP	
SW	R2, Offset(_temp+0)(GP)
;MPU_IMU_I2C.c,93 :: 		gyro_x += Gyrox_offset;
LW	R6, Offset(_gyro_x+0)(GP)
LUI	R4, 16467
ORI	R4, R4, 13107
JAL	__Add_FP+0
NOP	
SW	R2, Offset(_gyro_x+0)(GP)
;MPU_IMU_I2C.c,94 :: 		gyro_y += Gyroy_offset;
;MPU_IMU_I2C.c,95 :: 		gyro_z += Gyroz_offset;
;MPU_IMU_I2C.c,96 :: 		}
L_end_Set_Offset:
LW	RA, 0(SP)
ADDIU	SP, SP, 4
JR	RA
NOP	
; end of _Set_Offset
_Convert_Readings_To_String:
;MPU_IMU_I2C.c,99 :: 		void Convert_Readings_To_String() {
ADDIU	SP, SP, -4
SW	RA, 0(SP)
;MPU_IMU_I2C.c,101 :: 		sprintf(accel_x_out, "%.3f", accel_x);
LW	R2, Offset(_accel_x+0)(GP)
ADDIU	SP, SP, -12
SW	R2, 8(SP)
LUI	R2, #hi_addr(?lstr_1_MPU_IMU_I2C+0)
ORI	R2, R2, #lo_addr(?lstr_1_MPU_IMU_I2C+0)
SW	R2, 4(SP)
LUI	R2, #hi_addr(_accel_x_out+0)
ORI	R2, R2, #lo_addr(_accel_x_out+0)
SW	R2, 0(SP)
JAL	_sprintf+0
NOP	
ADDIU	SP, SP, 12
;MPU_IMU_I2C.c,102 :: 		sprintf(accel_y_out, "%.3f", accel_y);
LW	R2, Offset(_accel_y+0)(GP)
ADDIU	SP, SP, -12
SW	R2, 8(SP)
LUI	R2, #hi_addr(?lstr_2_MPU_IMU_I2C+0)
ORI	R2, R2, #lo_addr(?lstr_2_MPU_IMU_I2C+0)
SW	R2, 4(SP)
LUI	R2, #hi_addr(_accel_y_out+0)
ORI	R2, R2, #lo_addr(_accel_y_out+0)
SW	R2, 0(SP)
JAL	_sprintf+0
NOP	
ADDIU	SP, SP, 12
;MPU_IMU_I2C.c,103 :: 		sprintf(accel_z_out, "%.3f", accel_z);
LW	R2, Offset(_accel_z+0)(GP)
ADDIU	SP, SP, -12
SW	R2, 8(SP)
LUI	R2, #hi_addr(?lstr_3_MPU_IMU_I2C+0)
ORI	R2, R2, #lo_addr(?lstr_3_MPU_IMU_I2C+0)
SW	R2, 4(SP)
LUI	R2, #hi_addr(_accel_z_out+0)
ORI	R2, R2, #lo_addr(_accel_z_out+0)
SW	R2, 0(SP)
JAL	_sprintf+0
NOP	
ADDIU	SP, SP, 12
;MPU_IMU_I2C.c,106 :: 		sprintf(temp_out, "%.3f", temp_out);
LUI	R2, #hi_addr(_temp_out+0)
ORI	R2, R2, #lo_addr(_temp_out+0)
ADDIU	SP, SP, -12
SW	R2, 8(SP)
LUI	R2, #hi_addr(?lstr_4_MPU_IMU_I2C+0)
ORI	R2, R2, #lo_addr(?lstr_4_MPU_IMU_I2C+0)
SW	R2, 4(SP)
LUI	R2, #hi_addr(_temp_out+0)
ORI	R2, R2, #lo_addr(_temp_out+0)
SW	R2, 0(SP)
JAL	_sprintf+0
NOP	
ADDIU	SP, SP, 12
;MPU_IMU_I2C.c,110 :: 		sprintf(gyro_x_out, "%.3f", gyro_x);
LW	R2, Offset(_gyro_x+0)(GP)
ADDIU	SP, SP, -12
SW	R2, 8(SP)
LUI	R2, #hi_addr(?lstr_5_MPU_IMU_I2C+0)
ORI	R2, R2, #lo_addr(?lstr_5_MPU_IMU_I2C+0)
SW	R2, 4(SP)
LUI	R2, #hi_addr(_gyro_x_out+0)
ORI	R2, R2, #lo_addr(_gyro_x_out+0)
SW	R2, 0(SP)
JAL	_sprintf+0
NOP	
ADDIU	SP, SP, 12
;MPU_IMU_I2C.c,111 :: 		sprintf(gyro_y_out, "%.3f", gyro_y);
LW	R2, Offset(_gyro_y+0)(GP)
ADDIU	SP, SP, -12
SW	R2, 8(SP)
LUI	R2, #hi_addr(?lstr_6_MPU_IMU_I2C+0)
ORI	R2, R2, #lo_addr(?lstr_6_MPU_IMU_I2C+0)
SW	R2, 4(SP)
LUI	R2, #hi_addr(_gyro_y_out+0)
ORI	R2, R2, #lo_addr(_gyro_y_out+0)
SW	R2, 0(SP)
JAL	_sprintf+0
NOP	
ADDIU	SP, SP, 12
;MPU_IMU_I2C.c,112 :: 		sprintf(gyro_z_out, "%.3f", gyro_z);
LW	R2, Offset(_gyro_z+0)(GP)
ADDIU	SP, SP, -12
SW	R2, 8(SP)
LUI	R2, #hi_addr(?lstr_7_MPU_IMU_I2C+0)
ORI	R2, R2, #lo_addr(?lstr_7_MPU_IMU_I2C+0)
SW	R2, 4(SP)
LUI	R2, #hi_addr(_gyro_z_out+0)
ORI	R2, R2, #lo_addr(_gyro_z_out+0)
SW	R2, 0(SP)
JAL	_sprintf+0
NOP	
ADDIU	SP, SP, 12
;MPU_IMU_I2C.c,114 :: 		}
L_end_Convert_Readings_To_String:
LW	RA, 0(SP)
ADDIU	SP, SP, 4
JR	RA
NOP	
; end of _Convert_Readings_To_String
_Process_MPU_Data:
;MPU_IMU_I2C.c,116 :: 		void Process_MPU_Data(){
ADDIU	SP, SP, -20
SW	RA, 0(SP)
;MPU_IMU_I2C.c,117 :: 		while(INT != 1)              // Wait until INT line becomes 1
SW	R25, 4(SP)
SW	R26, 8(SP)
SW	R27, 12(SP)
SW	R28, 16(SP)
L_Process_MPU_Data16:
_LX	, 4
EXT	R2, R2, BitPos(RE8_bit+0), 1
BEQ	R2, 1, L__Process_MPU_Data34
NOP	
J	L_Process_MPU_Data17
NOP	
L__Process_MPU_Data34:
;MPU_IMU_I2C.c,118 :: 		;
J	L_Process_MPU_Data16
NOP	
L_Process_MPU_Data17:
;MPU_IMU_I2C.c,119 :: 		MPU_I2C_Read_Int(mpu_I2C_ADDR, mpu_rm_ACCEL_XOUT_H, 7, &raw_data);   // Read data from MPU
LUI	R28, #hi_addr(_raw_data+0)
ORI	R28, R28, #lo_addr(_raw_data+0)
ORI	R27, R0, 7
ORI	R26, R0, 59
ORI	R25, R0, 210
JAL	_MPU_I2C_Read_Int+0
NOP	
;MPU_IMU_I2C.c,120 :: 		Extract_Readings();                                                  // Extract data from the readings
JAL	_Extract_Readings+0
NOP	
;MPU_IMU_I2C.c,121 :: 		Set_Offset();                                                        // Set offset
JAL	_Set_Offset+0
NOP	
;MPU_IMU_I2C.c,122 :: 		Convert_Readings_To_String();                                        // Convert readings to strings
JAL	_Convert_Readings_To_String+0
NOP	
;MPU_IMU_I2C.c,123 :: 		}
L_end_Process_MPU_Data:
LW	R28, 16(SP)
LW	R27, 12(SP)
LW	R26, 8(SP)
LW	R25, 4(SP)
LW	RA, 0(SP)
ADDIU	SP, SP, 20
JR	RA
NOP	
; end of _Process_MPU_Data
_Print_Readings_UART:
;MPU_IMU_I2C.c,127 :: 		void Print_Readings_UART() {
ADDIU	SP, SP, -8
SW	RA, 0(SP)
;MPU_IMU_I2C.c,130 :: 		UART2_Write_Text("Gyro readings :");
SW	R25, 4(SP)
LUI	R25, #hi_addr(?lstr8_MPU_IMU_I2C+0)
ORI	R25, R25, #lo_addr(?lstr8_MPU_IMU_I2C+0)
JAL	_UART2_Write_Text+0
NOP	
;MPU_IMU_I2C.c,131 :: 		UART2_Write(0x0D);
ORI	R25, R0, 13
JAL	_UART2_Write+0
NOP	
;MPU_IMU_I2C.c,132 :: 		UART2_Write_Text("x = ");
LUI	R25, #hi_addr(?lstr9_MPU_IMU_I2C+0)
ORI	R25, R25, #lo_addr(?lstr9_MPU_IMU_I2C+0)
JAL	_UART2_Write_Text+0
NOP	
;MPU_IMU_I2C.c,133 :: 		UART2_Write_Text(gyro_x_out);
LUI	R25, #hi_addr(_gyro_x_out+0)
ORI	R25, R25, #lo_addr(_gyro_x_out+0)
JAL	_UART2_Write_Text+0
NOP	
;MPU_IMU_I2C.c,134 :: 		UART2_Write(0x0D);
ORI	R25, R0, 13
JAL	_UART2_Write+0
NOP	
;MPU_IMU_I2C.c,135 :: 		UART2_Write_Text("y = ");
LUI	R25, #hi_addr(?lstr10_MPU_IMU_I2C+0)
ORI	R25, R25, #lo_addr(?lstr10_MPU_IMU_I2C+0)
JAL	_UART2_Write_Text+0
NOP	
;MPU_IMU_I2C.c,136 :: 		UART2_Write_Text(gyro_y_out);
LUI	R25, #hi_addr(_gyro_y_out+0)
ORI	R25, R25, #lo_addr(_gyro_y_out+0)
JAL	_UART2_Write_Text+0
NOP	
;MPU_IMU_I2C.c,137 :: 		UART2_Write(0x0D);
ORI	R25, R0, 13
JAL	_UART2_Write+0
NOP	
;MPU_IMU_I2C.c,138 :: 		UART2_Write_Text("z = ");
LUI	R25, #hi_addr(?lstr11_MPU_IMU_I2C+0)
ORI	R25, R25, #lo_addr(?lstr11_MPU_IMU_I2C+0)
JAL	_UART2_Write_Text+0
NOP	
;MPU_IMU_I2C.c,139 :: 		UART2_Write_Text(gyro_z_out);
LUI	R25, #hi_addr(_gyro_z_out+0)
ORI	R25, R25, #lo_addr(_gyro_z_out+0)
JAL	_UART2_Write_Text+0
NOP	
;MPU_IMU_I2C.c,140 :: 		UART2_Write(0x0D);
ORI	R25, R0, 13
JAL	_UART2_Write+0
NOP	
;MPU_IMU_I2C.c,141 :: 		UART2_Write(0x0D);
ORI	R25, R0, 13
JAL	_UART2_Write+0
NOP	
;MPU_IMU_I2C.c,142 :: 		UART2_Write(0x0D);
ORI	R25, R0, 13
JAL	_UART2_Write+0
NOP	
;MPU_IMU_I2C.c,145 :: 		UART2_Write_Text("Accel readings :");
LUI	R25, #hi_addr(?lstr12_MPU_IMU_I2C+0)
ORI	R25, R25, #lo_addr(?lstr12_MPU_IMU_I2C+0)
JAL	_UART2_Write_Text+0
NOP	
;MPU_IMU_I2C.c,146 :: 		UART2_Write(0x0D);
ORI	R25, R0, 13
JAL	_UART2_Write+0
NOP	
;MPU_IMU_I2C.c,147 :: 		UART2_Write_Text("x = ");
LUI	R25, #hi_addr(?lstr13_MPU_IMU_I2C+0)
ORI	R25, R25, #lo_addr(?lstr13_MPU_IMU_I2C+0)
JAL	_UART2_Write_Text+0
NOP	
;MPU_IMU_I2C.c,148 :: 		UART2_Write_Text(accel_x_out);
LUI	R25, #hi_addr(_accel_x_out+0)
ORI	R25, R25, #lo_addr(_accel_x_out+0)
JAL	_UART2_Write_Text+0
NOP	
;MPU_IMU_I2C.c,149 :: 		UART2_Write(0x0D);
ORI	R25, R0, 13
JAL	_UART2_Write+0
NOP	
;MPU_IMU_I2C.c,150 :: 		UART2_Write_Text("y = ");
LUI	R25, #hi_addr(?lstr14_MPU_IMU_I2C+0)
ORI	R25, R25, #lo_addr(?lstr14_MPU_IMU_I2C+0)
JAL	_UART2_Write_Text+0
NOP	
;MPU_IMU_I2C.c,151 :: 		UART2_Write_Text(accel_y_out);
LUI	R25, #hi_addr(_accel_y_out+0)
ORI	R25, R25, #lo_addr(_accel_y_out+0)
JAL	_UART2_Write_Text+0
NOP	
;MPU_IMU_I2C.c,152 :: 		UART2_Write(0x0D);
ORI	R25, R0, 13
JAL	_UART2_Write+0
NOP	
;MPU_IMU_I2C.c,153 :: 		UART2_Write_Text("z = ");
LUI	R25, #hi_addr(?lstr15_MPU_IMU_I2C+0)
ORI	R25, R25, #lo_addr(?lstr15_MPU_IMU_I2C+0)
JAL	_UART2_Write_Text+0
NOP	
;MPU_IMU_I2C.c,154 :: 		UART2_Write_Text(accel_z_out);
LUI	R25, #hi_addr(_accel_z_out+0)
ORI	R25, R25, #lo_addr(_accel_z_out+0)
JAL	_UART2_Write_Text+0
NOP	
;MPU_IMU_I2C.c,155 :: 		UART2_Write(0x0D);
ORI	R25, R0, 13
JAL	_UART2_Write+0
NOP	
;MPU_IMU_I2C.c,156 :: 		UART2_Write(0x0D);
ORI	R25, R0, 13
JAL	_UART2_Write+0
NOP	
;MPU_IMU_I2C.c,157 :: 		UART2_Write(0x0D);
ORI	R25, R0, 13
JAL	_UART2_Write+0
NOP	
;MPU_IMU_I2C.c,160 :: 		UART2_Write_Text("Temperature readings (Celsius) = ");
LUI	R25, #hi_addr(?lstr16_MPU_IMU_I2C+0)
ORI	R25, R25, #lo_addr(?lstr16_MPU_IMU_I2C+0)
JAL	_UART2_Write_Text+0
NOP	
;MPU_IMU_I2C.c,161 :: 		UART2_Write_Text(temp_out);
LUI	R25, #hi_addr(_temp_out+0)
ORI	R25, R25, #lo_addr(_temp_out+0)
JAL	_UART2_Write_Text+0
NOP	
;MPU_IMU_I2C.c,162 :: 		UART2_Write(0x0D);
ORI	R25, R0, 13
JAL	_UART2_Write+0
NOP	
;MPU_IMU_I2C.c,163 :: 		UART2_Write(0x0D);
ORI	R25, R0, 13
JAL	_UART2_Write+0
NOP	
;MPU_IMU_I2C.c,164 :: 		UART2_Write(0x0D);
ORI	R25, R0, 13
JAL	_UART2_Write+0
NOP	
;MPU_IMU_I2C.c,165 :: 		}
L_end_Print_Readings_UART:
LW	R25, 4(SP)
LW	RA, 0(SP)
ADDIU	SP, SP, 8
JR	RA
NOP	
; end of _Print_Readings_UART
_MPU_I2C_Write:
;MPU_IMU_I2C.c,168 :: 		void MPU_I2C_Write(unsigned char s_addr, unsigned char r_addr, unsigned char len, unsigned char *dat) {
ADDIU	SP, SP, -12
SW	RA, 0(SP)
;MPU_IMU_I2C.c,171 :: 		I2C2_Start();                         // issue I2C start signal
SW	R25, 4(SP)
JAL	_I2C2_Start+0
NOP	
;MPU_IMU_I2C.c,172 :: 		I2C2_Write(s_addr & 0xFE);            // send byte via I2C  (device address + W(&0xFE))
ANDI	R2, R25, 254
ANDI	R25, R2, 255
JAL	_I2C2_Write+0
NOP	
;MPU_IMU_I2C.c,173 :: 		I2C2_Write(r_addr);                   // send byte (address of EEPROM location)
ANDI	R25, R26, 255
JAL	_I2C2_Write+0
NOP	
;MPU_IMU_I2C.c,174 :: 		for (i = 0 ; i < len ; i++){
; i start address is: 16 (R4)
MOVZ	R4, R0, R0
; i end address is: 16 (R4)
L_MPU_I2C_Write18:
; i start address is: 16 (R4)
ANDI	R3, R4, 65535
ANDI	R2, R27, 255
SLTU	R2, R3, R2
BNE	R2, R0, L__MPU_I2C_Write37
NOP	
J	L_MPU_I2C_Write19
NOP	
L__MPU_I2C_Write37:
;MPU_IMU_I2C.c,175 :: 		I2C2_Write(*dat++);                 // send data (data to be written)
SB	R25, 8(SP)
LBU	R25, 0(R28)
JAL	_I2C2_Write+0
NOP	
LBU	R25, 8(SP)
ADDIU	R2, R28, 1
MOVZ	R28, R2, R0
;MPU_IMU_I2C.c,174 :: 		for (i = 0 ; i < len ; i++){
ADDIU	R2, R4, 1
ANDI	R4, R2, 65535
;MPU_IMU_I2C.c,176 :: 		}
; i end address is: 16 (R4)
J	L_MPU_I2C_Write18
NOP	
L_MPU_I2C_Write19:
;MPU_IMU_I2C.c,177 :: 		I2C2_Stop();                          // issue I2C stop signal
JAL	_I2C2_Stop+0
NOP	
;MPU_IMU_I2C.c,178 :: 		}
L_end_MPU_I2C_Write:
LW	R25, 4(SP)
LW	RA, 0(SP)
ADDIU	SP, SP, 12
JR	RA
NOP	
; end of _MPU_I2C_Write
_MPU_I2C_Read:
;MPU_IMU_I2C.c,182 :: 		void MPU_I2C_Read(unsigned char s_addr, unsigned char r_addr, unsigned char len, unsigned char *dat) {
ADDIU	SP, SP, -12
SW	RA, 0(SP)
;MPU_IMU_I2C.c,184 :: 		I2C2_Start();                         // issue I2C start signal
SW	R25, 4(SP)
JAL	_I2C2_Start+0
NOP	
;MPU_IMU_I2C.c,185 :: 		I2C2_Write(s_addr & 0xFE);            // send byte via I2C  (device address + W(&0xFE))
ANDI	R2, R25, 254
SB	R25, 8(SP)
ANDI	R25, R2, 255
JAL	_I2C2_Write+0
NOP	
;MPU_IMU_I2C.c,186 :: 		I2C2_Write(r_addr);                   // send byte (data address)
ANDI	R25, R26, 255
JAL	_I2C2_Write+0
NOP	
LBU	R25, 8(SP)
;MPU_IMU_I2C.c,187 :: 		I2C2_Restart();                       // issue I2C signal repeated start
JAL	_I2C2_Restart+0
NOP	
;MPU_IMU_I2C.c,188 :: 		I2C2_Write(s_addr | 0x01);            // send byte (device address + R(|0x01))
ORI	R2, R25, 1
ANDI	R25, R2, 255
JAL	_I2C2_Write+0
NOP	
;MPU_IMU_I2C.c,189 :: 		for (i = 0; i < (len-1); i++){
; i start address is: 16 (R4)
MOVZ	R4, R0, R0
; i end address is: 16 (R4)
L_MPU_I2C_Read21:
; i start address is: 16 (R4)
ANDI	R2, R27, 255
ADDIU	R2, R2, -1
ANDI	R3, R4, 65535
SEH	R2, R2
SLTU	R2, R3, R2
BNE	R2, R0, L__MPU_I2C_Read39
NOP	
J	L_MPU_I2C_Read22
NOP	
L__MPU_I2C_Read39:
;MPU_IMU_I2C.c,190 :: 		*dat++ = I2C2_Read(_I2C_ACK);      // Read the data (acknowledge)
SB	R25, 8(SP)
MOVZ	R25, R0, R0
JAL	_I2C2_Read+0
NOP	
LBU	R25, 8(SP)
SB	R2, 0(R28)
ADDIU	R2, R28, 1
MOVZ	R28, R2, R0
;MPU_IMU_I2C.c,189 :: 		for (i = 0; i < (len-1); i++){
ADDIU	R2, R4, 1
ANDI	R4, R2, 65535
;MPU_IMU_I2C.c,191 :: 		}
; i end address is: 16 (R4)
J	L_MPU_I2C_Read21
NOP	
L_MPU_I2C_Read22:
;MPU_IMU_I2C.c,192 :: 		*dat = I2C2_Read(_I2C_NACK);         // Read the data (NO acknowledge)
SB	R25, 8(SP)
ORI	R25, R0, 1
JAL	_I2C2_Read+0
NOP	
LBU	R25, 8(SP)
SB	R2, 0(R28)
;MPU_IMU_I2C.c,193 :: 		I2C2_Stop();                         // issue I2C stop signal
JAL	_I2C2_Stop+0
NOP	
;MPU_IMU_I2C.c,194 :: 		}
L_end_MPU_I2C_Read:
LW	R25, 4(SP)
LW	RA, 0(SP)
ADDIU	SP, SP, 12
JR	RA
NOP	
; end of _MPU_I2C_Read
_MPU_I2C_Read_Int:
;MPU_IMU_I2C.c,196 :: 		void MPU_I2C_Read_Int(unsigned char s_addr, unsigned char r_addr, unsigned char len, unsigned char *dat) {
ADDIU	SP, SP, -20
SW	RA, 0(SP)
;MPU_IMU_I2C.c,199 :: 		I2C2_Start();                         // issue I2C start signal
SW	R25, 4(SP)
JAL	_I2C2_Start+0
NOP	
;MPU_IMU_I2C.c,200 :: 		I2C2_Write(s_addr & 0xFE);            // send byte via I2C  (device address + W(&0xFE))
ANDI	R2, R25, 254
SB	R25, 8(SP)
ANDI	R25, R2, 255
JAL	_I2C2_Write+0
NOP	
;MPU_IMU_I2C.c,201 :: 		I2C2_Write(r_addr);                      // send byte (data address)
ANDI	R25, R26, 255
JAL	_I2C2_Write+0
NOP	
LBU	R25, 8(SP)
;MPU_IMU_I2C.c,202 :: 		I2C2_Restart();                       // issue I2C signal repeated start
JAL	_I2C2_Restart+0
NOP	
;MPU_IMU_I2C.c,203 :: 		I2C2_Write(s_addr | 0x01);            // send byte (device address + R(|0x01))
ORI	R2, R25, 1
ANDI	R25, R2, 255
JAL	_I2C2_Write+0
NOP	
;MPU_IMU_I2C.c,204 :: 		for (i = 0 ; i < ((len << 1)-1) ; i++){
; i start address is: 16 (R4)
MOVZ	R4, R0, R0
; i end address is: 16 (R4)
L_MPU_I2C_Read_Int24:
; i start address is: 16 (R4)
ANDI	R2, R27, 255
SLL	R2, R2, 1
ADDIU	R2, R2, -1
ANDI	R3, R4, 65535
ANDI	R2, R2, 65535
SLTU	R2, R3, R2
BNE	R2, R0, L__MPU_I2C_Read_Int41
NOP	
J	L_MPU_I2C_Read_Int25
NOP	
L__MPU_I2C_Read_Int41:
;MPU_IMU_I2C.c,205 :: 		if (i%2) {
ANDI	R2, R4, 1
BNE	R2, R0, L__MPU_I2C_Read_Int43
NOP	
J	L_MPU_I2C_Read_Int27
NOP	
L__MPU_I2C_Read_Int43:
;MPU_IMU_I2C.c,206 :: 		pt = pt - 1;
LW	R2, 12(SP)
ADDIU	R2, R2, -1
SW	R2, 12(SP)
;MPU_IMU_I2C.c,207 :: 		}
J	L_MPU_I2C_Read_Int28
NOP	
L_MPU_I2C_Read_Int27:
;MPU_IMU_I2C.c,209 :: 		pt = dat + i + 1;
ANDI	R2, R4, 65535
ADDU	R2, R28, R2
ADDIU	R2, R2, 1
SW	R2, 12(SP)
;MPU_IMU_I2C.c,210 :: 		}
L_MPU_I2C_Read_Int28:
;MPU_IMU_I2C.c,211 :: 		*pt = I2C2_Read(_I2C_ACK);          // Read the data (acknowledge)
SB	R25, 8(SP)
MOVZ	R25, R0, R0
JAL	_I2C2_Read+0
NOP	
LBU	R25, 8(SP)
LW	R3, 12(SP)
SB	R2, 0(R3)
;MPU_IMU_I2C.c,204 :: 		for (i = 0 ; i < ((len << 1)-1) ; i++){
ADDIU	R2, R4, 1
ANDI	R4, R2, 65535
;MPU_IMU_I2C.c,212 :: 		}
; i end address is: 16 (R4)
J	L_MPU_I2C_Read_Int24
NOP	
L_MPU_I2C_Read_Int25:
;MPU_IMU_I2C.c,213 :: 		*(pt - 1) = I2C2_Read(_I2C_NACK);     // Read the data (NO acknowledge)
LW	R2, 12(SP)
ADDIU	R2, R2, -1
SW	R2, 16(SP)
SB	R25, 8(SP)
ORI	R25, R0, 1
JAL	_I2C2_Read+0
NOP	
LBU	R25, 8(SP)
LW	R3, 16(SP)
SB	R2, 0(R3)
;MPU_IMU_I2C.c,214 :: 		I2C2_Stop();                          // issue I2C stop signal
JAL	_I2C2_Stop+0
NOP	
;MPU_IMU_I2C.c,215 :: 		}
L_end_MPU_I2C_Read_Int:
LW	R25, 4(SP)
LW	RA, 0(SP)
ADDIU	SP, SP, 20
JR	RA
NOP	
; end of _MPU_I2C_Read_Int
