#line 1 "C:/Users/Alexander Wolf/Documents/PROJEKTE/104 QuadCop/Programming PIC/MPU IMO TFT/MPU_IMU_VTFT_v001_Code/mikroC PRO for PIC32/MPU_IMU_VTFT_v001_driver.c"
#line 1 "c:/users/alexander wolf/documents/projekte/104 quadcop/programming pic/mpu imo tft/mpu_imu_vtft_v001_code/mikroc pro for pic32/mpu_imu_vtft_v001_objects.h"
typedef struct Screen TScreen;

typedef struct Label {
 TScreen* OwnerScreen;
 char Order;
 unsigned int Left;
 unsigned int Top;
 unsigned int Width;
 unsigned int Height;
 char *Caption;
 const char *FontName;
 unsigned int Font_Color;
 char Visible;
 char Active;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TLabel;

typedef struct Circle {
 TScreen* OwnerScreen;
 char Order;
 unsigned int Left;
 unsigned int Top;
 unsigned int Radius;
 char Pen_Width;
 unsigned int Pen_Color;
 char Visible;
 char Active;
 char Transparent;
 char Gradient;
 char Gradient_Orientation;
 unsigned int Gradient_Start_Color;
 unsigned int Gradient_End_Color;
 unsigned int Color;
 char PressColEnabled;
 unsigned int Press_Color;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TCircle;

typedef struct Box {
 TScreen* OwnerScreen;
 char Order;
 unsigned int Left;
 unsigned int Top;
 unsigned int Width;
 unsigned int Height;
 char Pen_Width;
 unsigned int Pen_Color;
 char Visible;
 char Active;
 char Transparent;
 char Gradient;
 char Gradient_Orientation;
 unsigned int Gradient_Start_Color;
 unsigned int Gradient_End_Color;
 unsigned int Color;
 char PressColEnabled;
 unsigned int Press_Color;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TBox;

typedef struct Line {
 TScreen* OwnerScreen;
 char Order;
 unsigned int First_Point_X;
 unsigned int First_Point_Y;
 unsigned int Second_Point_X;
 unsigned int Second_Point_Y;
 char Pen_Width;
 char Visible;
 unsigned int Color;
} TLine;

struct Screen {
 unsigned int Color;
 unsigned int Width;
 unsigned int Height;
 unsigned int ObjectsCount;
 unsigned int LabelsCount;
 TLabel * const code *Labels;
 unsigned int CirclesCount;
 TCircle * const code *Circles;
 unsigned int BoxesCount;
 TBox * const code *Boxes;
 unsigned int LinesCount;
 TLine * const code *Lines;
};

extern TScreen Screen1;
extern TBox Box_Clear_Libelle;
extern TBox Box_Accel;
extern TBox Box_Gyro;
extern TCircle Circle1;
extern TCircle Circle2;
extern TLabel Label1;
extern TLabel Label2;
extern TLabel Label3;
extern TLabel Label4;
extern TLabel Label5;
extern TLabel Label6;
extern TLabel Label7;
extern TLabel Label8;
extern TLine Line_BasisX;
extern TLine Line_Y;
extern TLabel Label_Accel_X;
extern TLabel Label_Accel_Y;
extern TLabel Label_Accel_Z;
extern TLabel Label_Gyr_X;
extern TLabel Label_Gyr_Y;
extern TLabel Label_Gyr_Z;
extern TLabel Label9;
extern TLabel Label10;
extern TLabel * const code Screen1_Labels[16];
extern TCircle * const code Screen1_Circles[2];
extern TBox * const code Screen1_Boxes[3];
extern TLine * const code Screen1_Lines[2];








extern char Box_Clear_Libelle_Caption[];
extern char Box_Accel_Caption[];
extern char Box_Gyro_Caption[];
extern char Circle1_Caption[];
extern char Circle2_Caption[];
extern char Label1_Caption[];
extern char Label2_Caption[];
extern char Label3_Caption[];
extern char Label4_Caption[];
extern char Label5_Caption[];
extern char Label6_Caption[];
extern char Label7_Caption[];
extern char Label8_Caption[];
extern char Line_BasisX_Caption[];
extern char Line_Y_Caption[];
extern char Label_Accel_X_Caption[];
extern char Label_Accel_Y_Caption[];
extern char Label_Accel_Z_Caption[];
extern char Label_Gyr_X_Caption[];
extern char Label_Gyr_Y_Caption[];
extern char Label_Gyr_Z_Caption[];
extern char Label9_Caption[];
extern char Label10_Caption[];


void DrawScreen(TScreen *aScreen);
void DrawLabel(TLabel *ALabel);
void DrawCircle(TCircle *ACircle);
void DrawBox(TBox *ABox);
void DrawLine(TLine *Aline);
void Check_TP();
void Start_TP();
#line 1 "c:/users/alexander wolf/documents/projekte/104 quadcop/programming pic/mpu imo tft/mpu_imu_vtft_v001_code/mikroc pro for pic32/mpu_imu_vtft_v001_resources.h"
const code char Tahoma16x19_Regular[];
const code char Tahoma19x19_Bold[];
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for pic32/include/built_in.h"
#line 7 "C:/Users/Alexander Wolf/Documents/PROJEKTE/104 QuadCop/Programming PIC/MPU IMO TFT/MPU_IMU_VTFT_v001_Code/mikroC PRO for PIC32/MPU_IMU_VTFT_v001_driver.c"
char TFT_DataPort at LATE;
sbit TFT_RST at LATD7_bit;
sbit TFT_BLED at LATD2_bit;
sbit TFT_RS at LATD9_bit;
sbit TFT_CS at LATD10_bit;
sbit TFT_RD at LATD5_bit;
sbit TFT_WR at LATD4_bit;
char TFT_DataPort_Direction at TRISE;
sbit TFT_RST_Direction at TRISD7_bit;
sbit TFT_BLED_Direction at TRISD2_bit;
sbit TFT_RS_Direction at TRISD9_bit;
sbit TFT_CS_Direction at TRISD10_bit;
sbit TFT_RD_Direction at TRISD5_bit;
sbit TFT_WR_Direction at TRISD4_bit;



sbit DriveX_Left at LATB15_bit;
sbit DriveX_Right at LATB3_bit;
sbit DriveY_Up at LATB14_bit;
sbit DriveY_Down at LATB2_bit;
sbit DriveX_Left_Direction at TRISB15_bit;
sbit DriveX_Right_Direction at TRISB3_bit;
sbit DriveY_Up_Direction at TRISB14_bit;
sbit DriveY_Down_Direction at TRISB2_bit;



unsigned int Xcoord, Ycoord;
const ADC_THRESHOLD = 900;
char PenDown;
void *PressedObject;
int PressedObjectType;
unsigned int caption_length, caption_height;
unsigned int display_width, display_height;

int _object_count;
unsigned short object_pressed;
TLabel *local_label;
TLabel *exec_label;
int label_order;
TCircle *local_circle;
TCircle *exec_circle;
int circle_order;
TBox *local_box;
TBox *exec_box;
int box_order;

static void InitializeTouchPanel() {
 TFT_Init(320, 240);

}



 TScreen* CurrentScreen;

 TScreen Screen1;
 TBox Box_Clear_Libelle;
 TBox Box_Accel;
 TBox Box_Gyro;
 TCircle Circle1;
 TCircle Circle2;
 TLabel Label1;
char Label1_Caption[2] = "X";

 TLabel Label2;
char Label2_Caption[2] = "Y";

 TLabel Label3;
char Label3_Caption[2] = "Z";

 TLabel Label4;
char Label4_Caption[3] = "dX";

 TLabel Label5;
char Label5_Caption[3] = "dY";

 TLabel Label6;
char Label6_Caption[3] = "dZ";

 TLabel Label7;
char Label7_Caption[14] = "Accelerometer";

 TLabel Label8;
char Label8_Caption[10] = "Gyroscope";

 TLine Line_BasisX;
 TLine Line_Y;
 TLabel Label_Accel_X;
char Label_Accel_X_Caption[16] = "X";

 TLabel Label_Accel_Y;
char Label_Accel_Y_Caption[16] = "X";

 TLabel Label_Accel_Z;
char Label_Accel_Z_Caption[16] = "X";

 TLabel Label_Gyr_X;
char Label_Gyr_X_Caption[16] = "X";

 TLabel Label_Gyr_Y;
char Label_Gyr_Y_Caption[16] = "X";

 TLabel Label_Gyr_Z;
char Label_Gyr_Z_Caption[16] = "X";

 TLabel Label9;
char Label9_Caption[16] = "X";

 TLabel Label10;
char Label10_Caption[16] = "Y";

 TLabel * const code Screen1_Labels[16]=
 {
 &Label1,
 &Label2,
 &Label3,
 &Label4,
 &Label5,
 &Label6,
 &Label7,
 &Label8,
 &Label_Accel_X,
 &Label_Accel_Y,
 &Label_Accel_Z,
 &Label_Gyr_X,
 &Label_Gyr_Y,
 &Label_Gyr_Z,
 &Label9,
 &Label10
 };
 TCircle * const code Screen1_Circles[2]=
 {
 &Circle1,
 &Circle2
 };
 TBox * const code Screen1_Boxes[3]=
 {
 &Box_Clear_Libelle,
 &Box_Accel,
 &Box_Gyro
 };
 TLine * const code Screen1_Lines[2]=
 {
 &Line_BasisX,
 &Line_Y
 };



static void InitializeObjects() {
 Screen1.Color = 0xC618;
 Screen1.Width = 320;
 Screen1.Height = 240;
 Screen1.LabelsCount = 16;
 Screen1.Labels = Screen1_Labels;
 Screen1.CirclesCount = 2;
 Screen1.Circles = Screen1_Circles;
 Screen1.BoxesCount = 3;
 Screen1.Boxes = Screen1_Boxes;
 Screen1.LinesCount = 2;
 Screen1.Lines = Screen1_Lines;
 Screen1.ObjectsCount = 23;


 Box_Clear_Libelle.OwnerScreen = &Screen1;
 Box_Clear_Libelle.Order = 0;
 Box_Clear_Libelle.Left = 184;
 Box_Clear_Libelle.Top = 6;
 Box_Clear_Libelle.Width = 129;
 Box_Clear_Libelle.Height = 129;
 Box_Clear_Libelle.Pen_Width = 0;
 Box_Clear_Libelle.Pen_Color = 0x0000;
 Box_Clear_Libelle.Visible = 1;
 Box_Clear_Libelle.Active = 0;
 Box_Clear_Libelle.Transparent = 1;
 Box_Clear_Libelle.Gradient = 0;
 Box_Clear_Libelle.Gradient_Orientation = 0;
 Box_Clear_Libelle.Gradient_Start_Color = 0xFFFF;
 Box_Clear_Libelle.Gradient_End_Color = 0xC618;
 Box_Clear_Libelle.Color = 0xC618;
 Box_Clear_Libelle.PressColEnabled = 1;
 Box_Clear_Libelle.Press_Color = 0xE71C;
 Box_Clear_Libelle.OnUpPtr = 0;
 Box_Clear_Libelle.OnDownPtr = 0;
 Box_Clear_Libelle.OnClickPtr = 0;
 Box_Clear_Libelle.OnPressPtr = 0;

 Box_Accel.OwnerScreen = &Screen1;
 Box_Accel.Order = 1;
 Box_Accel.Left = 39;
 Box_Accel.Top = 48;
 Box_Accel.Width = 109;
 Box_Accel.Height = 65;
 Box_Accel.Pen_Width = 0;
 Box_Accel.Pen_Color = 0x0000;
 Box_Accel.Visible = 1;
 Box_Accel.Active = 0;
 Box_Accel.Transparent = 1;
 Box_Accel.Gradient = 0;
 Box_Accel.Gradient_Orientation = 0;
 Box_Accel.Gradient_Start_Color = 0xFFFF;
 Box_Accel.Gradient_End_Color = 0xC618;
 Box_Accel.Color = 0xC618;
 Box_Accel.PressColEnabled = 1;
 Box_Accel.Press_Color = 0xE71C;
 Box_Accel.OnUpPtr = 0;
 Box_Accel.OnDownPtr = 0;
 Box_Accel.OnClickPtr = 0;
 Box_Accel.OnPressPtr = 0;

 Box_Gyro.OwnerScreen = &Screen1;
 Box_Gyro.Order = 2;
 Box_Gyro.Left = 47;
 Box_Gyro.Top = 145;
 Box_Gyro.Width = 109;
 Box_Gyro.Height = 65;
 Box_Gyro.Pen_Width = 0;
 Box_Gyro.Pen_Color = 0x0000;
 Box_Gyro.Visible = 1;
 Box_Gyro.Active = 0;
 Box_Gyro.Transparent = 1;
 Box_Gyro.Gradient = 0;
 Box_Gyro.Gradient_Orientation = 0;
 Box_Gyro.Gradient_Start_Color = 0xFFFF;
 Box_Gyro.Gradient_End_Color = 0xC618;
 Box_Gyro.Color = 0xC618;
 Box_Gyro.PressColEnabled = 1;
 Box_Gyro.Press_Color = 0xE71C;
 Box_Gyro.OnUpPtr = 0;
 Box_Gyro.OnDownPtr = 0;
 Box_Gyro.OnClickPtr = 0;
 Box_Gyro.OnPressPtr = 0;

 Circle1.OwnerScreen = &Screen1;
 Circle1.Order = 3;
 Circle1.Left = 200;
 Circle1.Top = 20;
 Circle1.Radius = 50;
 Circle1.Pen_Width = 1;
 Circle1.Pen_Color = 0x0000;
 Circle1.Visible = 1;
 Circle1.Active = 1;
 Circle1.Transparent = 1;
 Circle1.Gradient = 0;
 Circle1.Gradient_Orientation = 0;
 Circle1.Gradient_Start_Color = 0xFFFF;
 Circle1.Gradient_End_Color = 0xC618;
 Circle1.Color = 0xFFE0;
 Circle1.PressColEnabled = 1;
 Circle1.Press_Color = 0xE71C;
 Circle1.OnUpPtr = 0;
 Circle1.OnDownPtr = 0;
 Circle1.OnClickPtr = 0;
 Circle1.OnPressPtr = 0;

 Circle2.OwnerScreen = &Screen1;
 Circle2.Order = 4;
 Circle2.Left = 251;
 Circle2.Top = 76;
 Circle2.Radius = 10;
 Circle2.Pen_Width = 1;
 Circle2.Pen_Color = 0x0000;
 Circle2.Visible = 1;
 Circle2.Active = 1;
 Circle2.Transparent = 1;
 Circle2.Gradient = 1;
 Circle2.Gradient_Orientation = 0;
 Circle2.Gradient_Start_Color = 0xFFFF;
 Circle2.Gradient_End_Color = 0xC618;
 Circle2.Color = 0xC618;
 Circle2.PressColEnabled = 1;
 Circle2.Press_Color = 0xE71C;
 Circle2.OnUpPtr = 0;
 Circle2.OnDownPtr = 0;
 Circle2.OnClickPtr = 0;
 Circle2.OnPressPtr = 0;

 Label1.OwnerScreen = &Screen1;
 Label1.Order = 5;
 Label1.Left = 25;
 Label1.Top = 48;
 Label1.Width = 10;
 Label1.Height = 21;
 Label1.Visible = 1;
 Label1.Active = 1;
 Label1.Caption = Label1_Caption;
 Label1.FontName = Tahoma16x19_Regular;
 Label1.Font_Color = 0x0000;
 Label1.OnUpPtr = 0;
 Label1.OnDownPtr = 0;
 Label1.OnClickPtr = 0;
 Label1.OnPressPtr = 0;

 Label2.OwnerScreen = &Screen1;
 Label2.Order = 6;
 Label2.Left = 25;
 Label2.Top = 69;
 Label2.Width = 9;
 Label2.Height = 21;
 Label2.Visible = 1;
 Label2.Active = 1;
 Label2.Caption = Label2_Caption;
 Label2.FontName = Tahoma16x19_Regular;
 Label2.Font_Color = 0x0000;
 Label2.OnUpPtr = 0;
 Label2.OnDownPtr = 0;
 Label2.OnClickPtr = 0;
 Label2.OnPressPtr = 0;

 Label3.OwnerScreen = &Screen1;
 Label3.Order = 7;
 Label3.Left = 25;
 Label3.Top = 90;
 Label3.Width = 9;
 Label3.Height = 21;
 Label3.Visible = 1;
 Label3.Active = 1;
 Label3.Caption = Label3_Caption;
 Label3.FontName = Tahoma16x19_Regular;
 Label3.Font_Color = 0x0000;
 Label3.OnUpPtr = 0;
 Label3.OnDownPtr = 0;
 Label3.OnClickPtr = 0;
 Label3.OnPressPtr = 0;

 Label4.OwnerScreen = &Screen1;
 Label4.Order = 8;
 Label4.Left = 25;
 Label4.Top = 146;
 Label4.Width = 19;
 Label4.Height = 21;
 Label4.Visible = 1;
 Label4.Active = 1;
 Label4.Caption = Label4_Caption;
 Label4.FontName = Tahoma16x19_Regular;
 Label4.Font_Color = 0x0000;
 Label4.OnUpPtr = 0;
 Label4.OnDownPtr = 0;
 Label4.OnClickPtr = 0;
 Label4.OnPressPtr = 0;

 Label5.OwnerScreen = &Screen1;
 Label5.Order = 9;
 Label5.Left = 25;
 Label5.Top = 167;
 Label5.Width = 19;
 Label5.Height = 21;
 Label5.Visible = 1;
 Label5.Active = 1;
 Label5.Caption = Label5_Caption;
 Label5.FontName = Tahoma16x19_Regular;
 Label5.Font_Color = 0x0000;
 Label5.OnUpPtr = 0;
 Label5.OnDownPtr = 0;
 Label5.OnClickPtr = 0;
 Label5.OnPressPtr = 0;

 Label6.OwnerScreen = &Screen1;
 Label6.Order = 10;
 Label6.Left = 25;
 Label6.Top = 189;
 Label6.Width = 18;
 Label6.Height = 21;
 Label6.Visible = 1;
 Label6.Active = 1;
 Label6.Caption = Label6_Caption;
 Label6.FontName = Tahoma16x19_Regular;
 Label6.Font_Color = 0x0000;
 Label6.OnUpPtr = 0;
 Label6.OnDownPtr = 0;
 Label6.OnClickPtr = 0;
 Label6.OnPressPtr = 0;

 Label7.OwnerScreen = &Screen1;
 Label7.Order = 11;
 Label7.Left = 25;
 Label7.Top = 27;
 Label7.Width = 120;
 Label7.Height = 21;
 Label7.Visible = 1;
 Label7.Active = 1;
 Label7.Caption = Label7_Caption;
 Label7.FontName = Tahoma19x19_Bold;
 Label7.Font_Color = 0x0000;
 Label7.OnUpPtr = 0;
 Label7.OnDownPtr = 0;
 Label7.OnClickPtr = 0;
 Label7.OnPressPtr = 0;

 Label8.OwnerScreen = &Screen1;
 Label8.Order = 12;
 Label8.Left = 25;
 Label8.Top = 124;
 Label8.Width = 87;
 Label8.Height = 21;
 Label8.Visible = 1;
 Label8.Active = 1;
 Label8.Caption = Label8_Caption;
 Label8.FontName = Tahoma19x19_Bold;
 Label8.Font_Color = 0x0000;
 Label8.OnUpPtr = 0;
 Label8.OnDownPtr = 0;
 Label8.OnClickPtr = 0;
 Label8.OnPressPtr = 0;

 Line_BasisX.OwnerScreen = &Screen1;
 Line_BasisX.Order = 13;
 Line_BasisX.First_Point_X = 190;
 Line_BasisX.First_Point_Y = 70;
 Line_BasisX.Second_Point_X = 310;
 Line_BasisX.Second_Point_Y = 70;
 Line_BasisX.Visible = 1;
 Line_BasisX.Pen_Width = 1;
 Line_BasisX.Color = 0x0000;

 Line_Y.OwnerScreen = &Screen1;
 Line_Y.Order = 14;
 Line_Y.First_Point_X = 250;
 Line_Y.First_Point_Y = 10;
 Line_Y.Second_Point_X = 250;
 Line_Y.Second_Point_Y = 130;
 Line_Y.Visible = 1;
 Line_Y.Pen_Width = 1;
 Line_Y.Color = 0x0000;

 Label_Accel_X.OwnerScreen = &Screen1;
 Label_Accel_X.Order = 15;
 Label_Accel_X.Left = 43;
 Label_Accel_X.Top = 48;
 Label_Accel_X.Width = 10;
 Label_Accel_X.Height = 21;
 Label_Accel_X.Visible = 1;
 Label_Accel_X.Active = 1;
 Label_Accel_X.Caption = Label_Accel_X_Caption;
 Label_Accel_X.FontName = Tahoma16x19_Regular;
 Label_Accel_X.Font_Color = 0x0000;
 Label_Accel_X.OnUpPtr = 0;
 Label_Accel_X.OnDownPtr = 0;
 Label_Accel_X.OnClickPtr = 0;
 Label_Accel_X.OnPressPtr = 0;

 Label_Accel_Y.OwnerScreen = &Screen1;
 Label_Accel_Y.Order = 16;
 Label_Accel_Y.Left = 43;
 Label_Accel_Y.Top = 69;
 Label_Accel_Y.Width = 10;
 Label_Accel_Y.Height = 21;
 Label_Accel_Y.Visible = 1;
 Label_Accel_Y.Active = 1;
 Label_Accel_Y.Caption = Label_Accel_Y_Caption;
 Label_Accel_Y.FontName = Tahoma16x19_Regular;
 Label_Accel_Y.Font_Color = 0x0000;
 Label_Accel_Y.OnUpPtr = 0;
 Label_Accel_Y.OnDownPtr = 0;
 Label_Accel_Y.OnClickPtr = 0;
 Label_Accel_Y.OnPressPtr = 0;

 Label_Accel_Z.OwnerScreen = &Screen1;
 Label_Accel_Z.Order = 17;
 Label_Accel_Z.Left = 43;
 Label_Accel_Z.Top = 91;
 Label_Accel_Z.Width = 10;
 Label_Accel_Z.Height = 21;
 Label_Accel_Z.Visible = 1;
 Label_Accel_Z.Active = 1;
 Label_Accel_Z.Caption = Label_Accel_Z_Caption;
 Label_Accel_Z.FontName = Tahoma16x19_Regular;
 Label_Accel_Z.Font_Color = 0x0000;
 Label_Accel_Z.OnUpPtr = 0;
 Label_Accel_Z.OnDownPtr = 0;
 Label_Accel_Z.OnClickPtr = 0;
 Label_Accel_Z.OnPressPtr = 0;

 Label_Gyr_X.OwnerScreen = &Screen1;
 Label_Gyr_X.Order = 18;
 Label_Gyr_X.Left = 51;
 Label_Gyr_X.Top = 145;
 Label_Gyr_X.Width = 10;
 Label_Gyr_X.Height = 21;
 Label_Gyr_X.Visible = 1;
 Label_Gyr_X.Active = 1;
 Label_Gyr_X.Caption = Label_Gyr_X_Caption;
 Label_Gyr_X.FontName = Tahoma16x19_Regular;
 Label_Gyr_X.Font_Color = 0x0000;
 Label_Gyr_X.OnUpPtr = 0;
 Label_Gyr_X.OnDownPtr = 0;
 Label_Gyr_X.OnClickPtr = 0;
 Label_Gyr_X.OnPressPtr = 0;

 Label_Gyr_Y.OwnerScreen = &Screen1;
 Label_Gyr_Y.Order = 19;
 Label_Gyr_Y.Left = 51;
 Label_Gyr_Y.Top = 167;
 Label_Gyr_Y.Width = 10;
 Label_Gyr_Y.Height = 21;
 Label_Gyr_Y.Visible = 1;
 Label_Gyr_Y.Active = 1;
 Label_Gyr_Y.Caption = Label_Gyr_Y_Caption;
 Label_Gyr_Y.FontName = Tahoma16x19_Regular;
 Label_Gyr_Y.Font_Color = 0x0000;
 Label_Gyr_Y.OnUpPtr = 0;
 Label_Gyr_Y.OnDownPtr = 0;
 Label_Gyr_Y.OnClickPtr = 0;
 Label_Gyr_Y.OnPressPtr = 0;

 Label_Gyr_Z.OwnerScreen = &Screen1;
 Label_Gyr_Z.Order = 20;
 Label_Gyr_Z.Left = 51;
 Label_Gyr_Z.Top = 189;
 Label_Gyr_Z.Width = 10;
 Label_Gyr_Z.Height = 21;
 Label_Gyr_Z.Visible = 1;
 Label_Gyr_Z.Active = 1;
 Label_Gyr_Z.Caption = Label_Gyr_Z_Caption;
 Label_Gyr_Z.FontName = Tahoma16x19_Regular;
 Label_Gyr_Z.Font_Color = 0x0000;
 Label_Gyr_Z.OnUpPtr = 0;
 Label_Gyr_Z.OnDownPtr = 0;
 Label_Gyr_Z.OnClickPtr = 0;
 Label_Gyr_Z.OnPressPtr = 0;

 Label9.OwnerScreen = &Screen1;
 Label9.Order = 21;
 Label9.Left = 174;
 Label9.Top = 60;
 Label9.Width = 10;
 Label9.Height = 21;
 Label9.Visible = 1;
 Label9.Active = 1;
 Label9.Caption = Label9_Caption;
 Label9.FontName = Tahoma16x19_Regular;
 Label9.Font_Color = 0x0000;
 Label9.OnUpPtr = 0;
 Label9.OnDownPtr = 0;
 Label9.OnClickPtr = 0;
 Label9.OnPressPtr = 0;

 Label10.OwnerScreen = &Screen1;
 Label10.Order = 22;
 Label10.Left = 245;
 Label10.Top = 135;
 Label10.Width = 9;
 Label10.Height = 21;
 Label10.Visible = 1;
 Label10.Active = 1;
 Label10.Caption = Label10_Caption;
 Label10.FontName = Tahoma16x19_Regular;
 Label10.Font_Color = 0x0000;
 Label10.OnUpPtr = 0;
 Label10.OnDownPtr = 0;
 Label10.OnClickPtr = 0;
 Label10.OnPressPtr = 0;
}

static char IsInsideObject (unsigned int X, unsigned int Y, unsigned int Left, unsigned int Top, unsigned int Width, unsigned int Height) {
 if ( (Left<= X) && (Left+ Width - 1 >= X) &&
 (Top <= Y) && (Top + Height - 1 >= Y) )
 return 1;
 else
 return 0;
}








void DrawLabel(TLabel *ALabel) {
 if (ALabel->Visible == 1) {
 TFT_Set_Font(ALabel->FontName, ALabel->Font_Color, FO_HORIZONTAL);
 TFT_Write_Text(ALabel->Caption, ALabel->Left, ALabel->Top);
 }
}

void DrawCircle(TCircle *ACircle) {
 if (ACircle->Visible == 1) {
 if (object_pressed == 1) {
 object_pressed = 0;
 TFT_Set_Brush(ACircle->Transparent, ACircle->Press_Color, ACircle->Gradient, ACircle->Gradient_Orientation,
 ACircle->Gradient_End_Color, ACircle->Gradient_Start_Color);
 }
 else {
 TFT_Set_Brush(ACircle->Transparent, ACircle->Color, ACircle->Gradient, ACircle->Gradient_Orientation,
 ACircle->Gradient_Start_Color, ACircle->Gradient_End_Color);
 }
 TFT_Set_Pen(ACircle->Pen_Color, ACircle->Pen_Width);
 TFT_Circle(ACircle->Left + ACircle->Radius,
 ACircle->Top + ACircle->Radius,
 ACircle->Radius);
 }
}

void DrawBox(TBox *ABox) {
 if (ABox->Visible == 1) {
 if (object_pressed == 1) {
 object_pressed = 0;
 TFT_Set_Brush(ABox->Transparent, ABox->Press_Color, ABox->Gradient, ABox->Gradient_Orientation, ABox->Gradient_End_Color, ABox->Gradient_Start_Color);
 }
 else {
 TFT_Set_Brush(ABox->Transparent, ABox->Color, ABox->Gradient, ABox->Gradient_Orientation, ABox->Gradient_Start_Color, ABox->Gradient_End_Color);
 }
 TFT_Set_Pen(ABox->Pen_Color, ABox->Pen_Width);
 TFT_Rectangle(ABox->Left, ABox->Top, ABox->Left + ABox->Width - 1, ABox->Top + ABox->Height - 1);
 }
}

void DrawLine(TLine *Aline) {
 if (Aline->Visible == 1) {
 TFT_Set_Pen(Aline->Color, Aline->Pen_Width);
 TFT_Line(Aline->First_Point_X, Aline->First_Point_Y, Aline->Second_Point_X, Aline->Second_Point_Y);
 }
}

void DrawScreen(TScreen *aScreen) {
 unsigned int order;
 unsigned short label_idx;
 TLabel *local_label;
 unsigned short circle_idx;
 TCircle *local_circle;
 unsigned short box_idx;
 TBox *local_box;
 unsigned short line_idx;
 TLine *local_line;
 char save_bled, save_bled_direction;

 object_pressed = 0;
 order = 0;
 label_idx = 0;
 circle_idx = 0;
 box_idx = 0;
 line_idx = 0;
 CurrentScreen = aScreen;

 if ((display_width != CurrentScreen->Width) || (display_height != CurrentScreen->Height)) {
 save_bled = TFT_BLED;
 save_bled_direction = TFT_BLED_Direction;
 TFT_BLED_Direction = 0;
 TFT_BLED = 0;
 TFT_Init(CurrentScreen->Width, CurrentScreen->Height);
 TFT_Fill_Screen(CurrentScreen->Color);
 display_width = CurrentScreen->Width;
 display_height = CurrentScreen->Height;
 TFT_BLED = save_bled;
 TFT_BLED_Direction = save_bled_direction;
 }
 else
 TFT_Fill_Screen(CurrentScreen->Color);


 while (order < CurrentScreen->ObjectsCount) {
 if (label_idx < CurrentScreen->LabelsCount) {
 local_label =  CurrentScreen->Labels[label_idx] ;
 if (order == local_label->Order) {
 label_idx++;
 order++;
 DrawLabel(local_label);
 }
 }

 if (circle_idx < CurrentScreen->CirclesCount) {
 local_circle =  CurrentScreen->Circles[circle_idx] ;
 if (order == local_circle->Order) {
 circle_idx++;
 order++;
 DrawCircle(local_circle);
 }
 }

 if (box_idx < CurrentScreen->BoxesCount) {
 local_box =  CurrentScreen->Boxes[box_idx] ;
 if (order == local_box->Order) {
 box_idx++;
 order++;
 DrawBox(local_box);
 }
 }

 if (line_idx < CurrentScreen->LinesCount) {
 local_line =  CurrentScreen->Lines[line_idx] ;
 if (order == local_line->Order) {
 line_idx++;
 order++;
 DrawLine(local_line);
 }
 }

 }
}

void Init_MCU() {
 AD1PCFG = 0x3FF3;
 JTAGEN_bit = 0;
 TFT_Set_Default_Mode();
 TP_TFT_Set_Default_Mode();
}

void Start_TP() {
 Init_MCU();

 InitializeTouchPanel();
 InitializeObjects();
 display_width = Screen1.Width;
 display_height = Screen1.Height;
 DrawScreen(&Screen1);
}
